/******************************************************************************
 *
 * Filename: linker.h
 *
 * Author:   Robert Thornburrow
 * Project:  JavaVM
 * Created:  19th January 1998
 *
 * Purpose:  Linker interface.
 *
 * (c) Copyright R.H.Thornburrow, 1998
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *****************************************************************************/

#ifndef _linker_h

#define _linker_h


#include "types.h"
#include "classfile.h"
#include "engine.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int compareUTF8( ClassFile* cf1, u2 index1, ClassFile* cf2, u2 index2 );
extern ClassFile* load( const char* classname, Stack* stp );
extern int initialise( ClassFile* cf, Stack* stp );
extern void linkClass( ClassFile* cf, u2 index, Stack* stp );
extern void linkFieldRef( ClassFile* cf, u2 index, Stack* stp );
extern void linkMethodRef( ClassFile* cf, u2 index, Stack* stp );
extern void linkInterfaceMethodRef( ClassFile* cf, u2 index, Stack* stp );


#ifdef __cplusplus
}
#endif


#endif
