/******************************************************************************
 *
 * Filename: loader.h
 *
 * Author:   Robert Thornburrow
 * Project:  JavaVM
 * Created:  19th January 1998
 *
 * Purpose:  Loader interface.
 *
 * (c) Copyright R.H.Thornburrow, 1998
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *****************************************************************************/

#ifndef _loader_h

#define _loader_h

#ifdef __cplusplus
extern "C" {
#endif


/**
 * Table of loaded classes - one entry per class - keyed on classname as
 * of v1.03.
 */
typedef struct _ClassFileRecord
{
	const char* classname;
	ClassFile* cf;
	struct _ClassFileRecord* next;
} ClassFileRecord;

extern ClassFileRecord* loadedTable;


extern ClassFile* checkLoaded( const char* classname );
extern ClassFile* readClassFile( const char* filename, const char* classname, struct _Stack* stp );


#ifdef __cplusplus
}
#endif


#endif
