/******************************************************************************
 *
 * Filename: boolean.c
 *
 * Author:   Robert Thornburrow
 * Project:  JavaVM
 * Created:  4th March 2002
 *
 * Purpose:  Include file for boolean instructions.
 *
 * (c) Copyright R.H.Thornburrow, 2002
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *****************************************************************************/

void dup( Frame* fp )
{
	INSTRUCTION( "%p: dup\n", fp->pc );
	DUP( fp );
}


void dup2( Frame* fp )
{
	u4 value[2];
	u1 type[2];

	INSTRUCTION( "%p: dup2\n", fp->pc );

	POP_ANY_TYPE( fp, value[0], type[0] );
	POP_ANY_TYPE( fp, value[1], type[1] );
	PUSH_ANY_TYPE( fp, value[1], type[1] );
	PUSH_ANY_TYPE( fp, value[0], type[0] );
	PUSH_ANY_TYPE( fp, value[1], type[1] );
	PUSH_ANY_TYPE( fp, value[0], type[0] );
}


void dup_x1( Frame* fp )
{
	u4 value1, value2;
	u1 type1, type2;

	INSTRUCTION( "%p: dup_x1\n", fp->pc );

	POP_ANY_TYPE( fp, value1, type1 );
	POP_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1, type1 );
	PUSH_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1, type1 );
}


void dup_x2( Frame* fp )
{
	u4 value1, value2, value3;
	u1 type1, type2, type3;

	INSTRUCTION( "%p: dup_x2\n", fp->pc );

	POP_ANY_TYPE( fp, value1, type1 );
	POP_ANY_TYPE( fp, value2, type2 );
	POP_ANY_TYPE( fp, value3, type3 );
	PUSH_ANY_TYPE( fp, value1, type1 );
	PUSH_ANY_TYPE( fp, value3, type3 );
	PUSH_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1, type1 );
}


void dup2_x1( Frame* fp )
{
	u4 value1[2], value2;
	u1 type1[2], type2;

	INSTRUCTION( "%p: dup2_x1\n", fp->pc );

	POP_ANY_TYPE( fp, value1[0], type1[0] );
	POP_ANY_TYPE( fp, value1[1], type1[1] );
	POP_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1[1], type1[1] );
	PUSH_ANY_TYPE( fp, value1[0], type1[0] );
	PUSH_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1[1], type1[1] );
	PUSH_ANY_TYPE( fp, value1[0], type1[0] );
}


void dup2_x2( Frame* fp )
{
	u4 value1[2], value2[2];
	u1 type1[2], type2[2];

	INSTRUCTION( "%p: dup2_x2\n", fp->pc );

	POP_ANY_TYPE( fp, value1[0], type1[0] );
	POP_ANY_TYPE( fp, value1[1], type1[1] );
	POP_ANY_TYPE( fp, value2[0], type2[0] );
	POP_ANY_TYPE( fp, value2[1], type2[1] );
	PUSH_ANY_TYPE( fp, value1[1], type1[1] );
	PUSH_ANY_TYPE( fp, value1[0], type1[0] );
	PUSH_ANY_TYPE( fp, value2[1], type2[1] );
	PUSH_ANY_TYPE( fp, value2[0], type2[0] );
	PUSH_ANY_TYPE( fp, value1[1], type1[1] );
	PUSH_ANY_TYPE( fp, value1[0], type1[0] );
}


void swap( Frame* fp )
{
	u4 value1, value2;
	u1 type1, type2;

	INSTRUCTION( "%p: swap\n", fp->pc );

	POP_ANY_TYPE( fp, value1, type1 );
	POP_ANY_TYPE( fp, value2, type2 );
	PUSH_ANY_TYPE( fp, value1, type1 );
	PUSH_ANY_TYPE( fp, value2, type2 );
}
