/******************************************************************************
 *
 * Filename: java_io_FileDescriptor.c
 *
 * Author:   Robert Thornburrow
 * Project:  JavaVM
 * Created:  19th January 1998
 *
 * Purpose:  Native method implementations for java.io.FileDescriptor.
 *
 * (c) Copyright R.H.Thornburrow, 2002
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *****************************************************************************/

#include "../engine/config.h"

#include "java_io_FileDescriptor.h"

#include "../engine/globals.h"


/* static java.io.FileDescriptor initSystemFD(java.io.FileDescriptor fdObj, int desc); */
jobject Java_java_io_FileDescriptor_initSystemFD( JNIEnv* env, jclass staticself, jobject fdObj, jint desc )
{
	switch( desc )
	{
	case 0: fdList[0] = stdin; break;
	case 1: fdList[1] = stdout; break;
	case 2: fdList[2] = stderr; break;
	}

	fdObj->data[0] = desc + 1;

	return fdObj;
}
