/******************************************************************************
 *
 * Filename: java_lang_ClassLoader.h
 *
 * Author:   Robert Thornburrow
 * Project:  JavaVM
 * Created:  19th January 1998
 *
 * Purpose:  Native method implementations for java.lang.ClassLoader.
 *
 * (c) Copyright R.H.Thornburrow, 2002
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *****************************************************************************/

#ifndef _java_lang_ClassLoader_h

#define _java_lang_ClassLoader_h


#include "../engine/native.h"


#ifdef __cplusplus
extern "C" {
#endif


extern void     Java_java_lang_ClassLoader_init( JNIEnv* env, jobject self );
extern jobject  Java_java_lang_ClassLoader_getSystemResourceAsStream0( JNIEnv* env, jclass cls, jobject str );
extern jclass   Java_java_lang_ClassLoader_findSystemClass0( JNIEnv* env, jobject self, jobject str );


#ifdef __cplusplus
}
#endif

#endif /* _java_lang_ClassLoader_h */
